//------------------------------------------------------------------------------
// File: JYPlayerApp.h
//
// Desc: Interface for the CJYPlayerApp class.
//
// Copyright (c) 2000 - 2005, L544 Technology.  All rights reserved.
//------------------------------------------------------------------------------

#if !defined(L544_APP_H__47EAC569_AA23_47EA_9E60_CB1332CD3804__INCLUDED_)
#define L544_APP_H__47EAC569_AA23_47EA_9E60_CB1332CD3804__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define WM_GRAPHNOTIFY	WM_APP + 1

interface IGraphBuilder;

	HRESULT ConnectFilters(IGraphBuilder* pGB, IBaseFilter* pUpFilter, IBaseFilter* pDownFilter, int nMAX=3);
//
// define CJYPlayerApp class
//

class CJYPlayerApp  
{
	friend int APIENTRY WinMain(HINSTANCE hInstance,
		HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);

// Construction
public:
	CJYPlayerApp() ;
	virtual ~CJYPlayerApp() ;
	
// Attributes
public:
	void SetAppValues(HINSTANCE hInst, PTSTR szAppName, int iAppTitleResId) ;

public:
	inline const TCHAR * GetAppName(void) const { return m_szAppName ; } ;

	static	BOOL CALLBACK DialogProc2(
		HWND hwndDlg,	// handle to dialog box
		UINT uiMsg,		// message
		WPARAM wParam,	// first message parameter
		LPARAM lParam	// second message parameter
		);

// Operations
public:
	bool InitInstance(int nCmdShow) ;
	void OnDraw(HDC hDC) ;

public:
	// File Menu
	HRESULT OnFileOpen() ;
	HRESULT OnFileClose() ;
	HRESULT OnFileOpenBit();
	// Control Menu
	HRESULT OnPlayClip() ;
	HRESULT OnPauseClip() ;
	HRESULT OnStopClip() ;

	HRESULT OnRewindClip() ;
	HRESULT OnFastForwardClip() ;
	HRESULT OnPreviousClip(LONGLONG pos=0) ;
	HRESULT OnNextClip() ;

	// Volume/Balance Menu
	HRESULT OnVolume(bool bUp);
	HRESULT OnBalance(bool bRight);

// Procedures
public:
	HRESULT GetPin( IBaseFilter * pFilter, PIN_DIRECTION dirrequired, int iNum, IPin **ppPin);
	HRESULT OnFilter();
	void CaptureView();
	static void DrawBitmap(HDC hdc, int x, int y, int w, int h, HBITMAP hbit);
	static HBITMAP MakeHBIT(HDC hdc);
	HRESULT OnURLOpen();
	void SaveImage(BITMAPINFOHEADER& bmiHeader, BYTE* pDIB);
	void CaptureScreen();
	void MoveTrackBar(HWND TrackBar, WORD Msg);
	void OnTimer();
	void StaticSetTime(HWND time);
    static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) ;
	
private:
	LRESULT MenuProc(HWND hWnd, WPARAM wParam, LPARAM lParam) ;
    LRESULT KeyProc(WPARAM wParam, LPARAM lParam) ;
	LRESULT ToolTipProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) ;

	// WM_SIZE
	HRESULT OnSize() ;

	// Video Window related
	HRESULT ToggleFullScreen() ;
	HRESULT StartFullScreen() ;
	HRESULT StopFullScreen() ;

	// Filter Graph Events
	HRESULT HandleGraphEvent(LPARAM lParam) ;

private:
    TCHAR               m_szAppName[50] ;   // internal name of the app
	TCHAR               m_szAppTitle[50] ;   // title bar text
	HINSTANCE           m_hInstance ;
	HWND                m_hWnd ;
	HWND                m_hwndToolBar ;

	int nowm;
	int nowh;
	int nows;
	int Imagetemp;
	HWND TotalTimer;
	HWND NowTimer;
	HWND Filename;
	HWND FileSeekTrackBar;
	LONGLONG FileTrackPos;
	LONGLONG SoundTrackPos;
	HWND SoundSeekTrackBar;
	LONGLONG totaltime;
	bool Die;
	bool TimerCheck;
	bool TimerCheck2;

private:
	TCHAR m_szFileName[MAX_PATH] ;
	TCHAR FileTitle[MAX_PATH];

#ifdef REGISTER_FILTERGRAPH
	DWORD				m_dwGraphRegister ;
#endif

	// Video window related
	bool	m_bFullScreenOn ;
	RECT	m_rectOrgVideo ;	// used to store the original video rectangle during fullscreen playback
    long	m_lOrgStyle ;		// original video window style bits (before fullscreen)
    long	m_lOrgStyleEx ;	// original video window extended style bits (.....)

	// Volume/Balance related
	float	m_fVolumePos;	// Volume Position
	float	m_fBalancePos;	// Balance Position

private:
	// DirectShow interfaces
	IGraphBuilder	*	m_pGB ;
	IBaseFilter	* m_pSG;
} ;

#endif // !defined(L544_APP_H__47EAC569_AA23_47EA_9E60_CB1332CD3804__INCLUDED_)
