// RenderURLDlg.cpp: implementation of the CRenderURLDlg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RenderURLDlg.h"
#include "resource.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// static member variables
LPTSTR CRenderURLDlg::m_pstrURL = NULL;
DWORD CRenderURLDlg::m_dwMaxURL = 0;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BOOL CRenderURLDlg::GetOpenURLName(HINSTANCE hInstance, HWND hWndParent, LPTSTR pstrURL, DWORD dwMaxURL)
{
	m_pstrURL = pstrURL;
	m_dwMaxURL = dwMaxURL;

	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_RENDER_URL), hWndParent, DialogProc);
}

/////////////////////////////////////////////////////////////////////////////
// CRenderURLDlg message handlers


INT_PTR CALLBACK CRenderURLDlg::DialogProc(HWND hwndDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uiMsg)
	{
	case WM_INITDIALOG:
		{
			HKEY hkeyFilter = 0;
			int rc = 0;
			TCHAR *pszKey = TEXT("Software\\Microsoft\\ActiveMovie\\GraphEdit\\URLPersistList");

			// open the registry key ...
			rc = RegOpenKey(HKEY_CURRENT_USER, pszKey, &hkeyFilter);
			if (rc == ERROR_SUCCESS)
			{
				DWORD dwSize;
				BYTE szURLName[MAX_URL_PATH];
				char szStringValue[5];

				// get combo box window
				HWND hWndCombo = GetDlgItem(hwndDlg, IDC_COMBO_URL);

				for (int i=0; i<6; i++)	// Graph Editor searches from URL0 to URL5!
				{
					wsprintf(szStringValue, "URL%d", i);
					
					// query the value
					rc = RegQueryValueEx(hkeyFilter, szStringValue,
						NULL, NULL, szURLName, &dwSize);

					if (rc == ERROR_SUCCESS)
						SendMessage(hWndCombo, CB_ADDSTRING, 0, (LPARAM)szURLName);
					else
						break;
				}
				SendMessage(hWndCombo, CB_SETCURSEL, i-1, 0);	// just like graph editor
				SendMessage(hWndCombo, CB_SETEDITSEL, 0, MAKELPARAM(0, -1));	// just like graph editor

				// close the registry key ...
				rc = RegCloseKey(hkeyFilter);
			}
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			GetDlgItemText(hwndDlg, IDC_COMBO_URL, m_pstrURL, m_dwMaxURL);
			EndDialog(hwndDlg, IDOK);
			return TRUE;

		case IDCANCEL:
			EndDialog(hwndDlg, IDCANCEL);
			return TRUE;
		}
	}

	return FALSE;
}
